
#----------------------------------------------------------
# QRcode image
# for LunarSystem V5
#
# ̃vOY.Swetakel
# Home:http://www.swetake.com/
# JꂽQRcode image CGI𓖃{WW[`
# ̂łB
#----------------------------------------------------------
#
#  QRcode image CGI    version 0.50e  (C)2000-2004,Y.Swetake
#
#
#  This program outputs a png image of "QRcode model 2". 
#  You cannot use a several functions of QRcode in this version. 
#  See README.txt .
#

package make_qr;

$path      ="make_qr_dat/data";    #---QRf[^tH_
$image_path="make_qr_dat/image";   #---QR t[f[^tH_
$err_file  ="make_qr_dat/";        #---QRG[f[^
@img_fn=("b.png","d.png");  #---TCY`C[W
$gd_flag   = "";

return 1;

sub main::make_qr{
	
	($str,$ecc_level,$msize,$imgtype,$qr_path) = @_;
	
	#---pXݒ
	$qr_path =~ s/[^\/\\]+$//;
	$path       = $qr_path.$path;
	$image_path = $qr_path.$image_path;
	$err_file   = $qr_path.$err_file;
	
	$qrcode_data_string   = $str;
	$qrcode_error_correct = $ecc_level;   #---ECC Level (L,M,Q,H)
	$qrcode_version       = "";           #---ɃI[g
	$qrcode_module_size   = $msize;       #---W[TCY(PNG=4,Jpeg=8)
	$qrcode_image_type    = $imgtype;     #---C[W^Cv(jpeg,png)
	$qrcode_structureappend_n = "";
	$qrcode_structureappend_m = "";
	$qrcode_structureappend_parity = "";
	$qrcode_structureappend_originaldata = "";
	($rc,*img_p) = &main_exec(40);
	if ($rc ne "1"){ return("0",&load_img($rc,$imgtype));}
	else{
		return("1",*img_p);
	}
}

sub load_img{
	
	($rc,$imgtype)= @_;
	
	if ($imgtype eq "jpg"){ $imgtype = ".jpg";}
	else                  { $imgtype = ".png";}
	
	$out_img = "";
	open(IN,$err_file."error_".$rc.$imgtype);
	binmode IN;
	while(<IN>){
		$out_img .= $_;
	}
	close(IN);
	
	return(*out_img);
}

sub main_exec{
	($max_qr_ver) = @_;
	
	# ---- determine image type
	if ($qrcode_image_type eq "jpg"){
		$qrcode_image_type="jpeg";
		$qrcode_module_size= 8 unless ($qrcode_module_size>0);
	} else {
		$qrcode_image_type="png";
		$qrcode_module_size= 4 unless ($qrcode_module_size>0);
	}
	
	$data_length=length($qrcode_data_string);
	if ($data_length <= 0){ return('nodata');}
	
	#---- structure append
	$data_counter=0;
	if ($qrcode_structureappend_n>1
	    && $qrcode_structureappend_n<=16
	    && $qrcode_structureappend_m<=16
	    && $qrcode_structureappend_m>0){
		
		$data_value[0]=3;    #--- structureappend mode
		$data_bits[0]=4;
		
		$data_value[1]=$qrcode_structureappend_m-1;
		$data_bits[1]=4;
		
		$data_value[2]=$qrcode_structureappend_n-1;
		$data_bits[2]=4;
		
		$originaldata_length=length($qrcode_structureappend_originaldata);
		if ($originaldata_length>1){
			$i=0;
			$qrcode_structureappend_parity=0;
			while ($i<$originaldata_length){
				$qrcode_structureappend_parity=($qrcode_structureappend_parity ^ ord(substr($qrcode_structureappend_originaldata,$i,1)));
				$i++;
			}
		}
		
		$data_value[3]=$qrcode_structureappend_parity;
		$data_bits[3]=8;
		
		$data_counter=4;
	}
	
	# --- determine encode mode
	
	$data_bits[$data_counter]=4;
	
	if ($qrcode_data_string=~ /[^0-9]/){
		if ($qrcode_data_string =~ /[^0-9A-Z \$\*\%\+\-\.\/\:]/) {
		
			# --- 8bit byte mode
			
			@codeword_num_plus=(0,0,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8);
			
			$data_value[$data_counter]=4;   # 8bit byte mode
			$data_counter++;
			$data_bits[$data_counter]=8;   # version 1-9
			$data_value[$data_counter]=$data_length;
			$codeword_num_counter_value=$data_counter;
			
			$i=0;
			$data_counter++;
			while ($i<$data_length){
				$data_value[$data_counter]=ord(substr($qrcode_data_string,$i,1));
				$data_bits[$data_counter]=8;
				$data_counter++;
				$i++;
			}
		}else{
			
			# ---- alphanumeric mode
			
			@codeword_num_plus=(0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4);
			
			$data_value[$data_counter]=2;            # alpha numeric mode
			$data_counter++;
			$data_value[$data_counter]=$data_length;
			$data_bits[$data_counter]=9;            #version 1-9
			
			$codeword_num_counter_value=$data_counter;
			
			%alphanumeric_character_hash=("0",0,"1",1,"2",2,"3",3,"4",4,"5",5,"6",6,"7",7,"8",8,"9",9,"A",10,
			"B",11,"C",12,"D",13,"E",14,"F",15,"G",16,"H",17,"I",18,"J",19,"K",20,
			"L",21,"M",22,"N",23,"O",24,"P",25,"Q",26,"R",27,"S",28,"T",29,"U",30,
			"V",31,"W",32,"X",33,"Y",34,"Z",35," ",36,"\$",37,"\%",38,"\*",39,
			"\+",40,"\-",41,"\.",42,"\/",43,"\:",44);
			$i=0;
			$data_counter++;
			while ($i<$data_length){
				if (($i %2)==0){
					$data_value[$data_counter]=$alphanumeric_character_hash{substr($qrcode_data_string,$i,1)};
					$data_bits[$data_counter]=6;
				}else{
					$data_value[$data_counter]=$data_value[$data_counter]*45+$alphanumeric_character_hash{substr($qrcode_data_string,$i,1)};
					$data_bits[$data_counter]=11;
					$data_counter++;
				}
				$i++;
			}
		}
	}else{
		
		# ---- numeric mode
		
		@codeword_num_plus=(0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,4,4,4,4,4,4,4,4,4,4,4,4,4,4);
		
		$data_value[$data_counter]=1;              # numeric mode
		$data_counter++;
		$data_value[$data_counter]=$data_length;   # length
		$data_bits[$data_counter]=10;             # version 1-9
		$codeword_num_counter_value=$data_counter;
		
		$i=0;
		$data_counter++;
		while ($i<$data_length){
			if (($i % 3)==0){
				$data_value[$data_counter]=substr($qrcode_data_string,$i,1);
				$data_bits[$data_counter]=4;
			}else{
				$data_value[$data_counter]=$data_value[$data_counter]*10+substr($qrcode_data_string,$i,1);
				if (($i % 3)==1){
					$data_bits[$data_counter]=7;
				}else{
					$data_bits[$data_counter]=10;
					$data_counter++;
				}
			}
			$i++;
		}
	}
	if ($data_bits[$data_counter]>0) {
		$data_counter++;
	}
	$i=0;
	$total_data_bits=0;
	while($i<$data_counter){
		$total_data_bits+=$data_bits[$i];
		$i++;
	}
	
	%ecc_character_hash=("L",1,"l",1,"M",0,"m",0,"Q",3,"q",3,"H",2,"h",2);
	
	$ecc=$ecc_character_hash{$qrcode_error_correct}; 
	
	if (!$ecc){$ecc=0;}
	
	@max_data_bits_array=(
		0,128,224,352,512,688,864,992,1232,1456,1728,
		2032,2320,2672,2920,3320,3624,4056,4504,5016,5352,
		5712,6256,6880,7312,8000,8496,9024,9544,10136,10984,
		11640,12328,13048,13800,14496,15312,15936,16816,17728,18672,
		
		152,272,440,640,864,1088,1248,1552,1856,2192,
		2592,2960,3424,3688,4184,4712,5176,5768,6360,6888,
		7456,8048,8752,9392,10208,10960,11744,12248,13048,13880,
		14744,15640,16568,17528,18448,19472,20528,21616,22496,23648,
		
		72,128,208,288,368,480,528,688,800,976,
		1120,1264,1440,1576,1784,2024,2264,2504,2728,3080,
		3248,3536,3712,4112,4304,4768,5024,5288,5608,5960,
		6344,6760,7208,7688,7888,8432,8768,9136,9776,10208,
		
		104,176,272,384,496,608,704,880,1056,1232,
		1440,1648,1952,2088,2360,2600,2936,3176,3560,3880,
		4096,4544,4912,5312,5744,6032,6464,6968,7288,7880,
		8264,8920,9368,9848,10288,10832,11408,12016,12656,13328
	);

	if (!$qrcode_version){        #--- auto version select
		$i=1+40*$ecc;
		$j=$i+($max_qr_ver-1);
		$qrcode_version=1;
		while ($i<=$j){
			if (($max_data_bits_array[$i])>=$total_data_bits+$codeword_num_plus[$qrcode_version]){
				$max_data_bits=$max_data_bits_array[$i];
				last;
			}
			$i++;
			$qrcode_version++;
		}
	}else{
		$max_data_bits=$max_data_bits_array[$qrcode_version+40*$ecc];
	}
	
	$total_data_bits+=$codeword_num_plus[$qrcode_version];
	$data_bits[$codeword_num_counter_value]+=$codeword_num_plus[$qrcode_version];
	
	@max_codewords_array=(0,26,44,70,100,134,172,196,242,
		292,346,404,466,532,581,655,733,815,901,991,1085,1156,
		1258,1364,1474,1588,1706,1828,1921,2051,2185,2323,2465,
		2611,2761,2876,3034,3196,3362,3532,3706);
		
	$max_codewords=$max_codewords_array[$qrcode_version];
	$max_modules_1side=17+($qrcode_version <<2);
	
	@matrix_remain_bit=(0,0,7,7,7,7,7,0,0,0,0,0,0,0,3,3,3,3,3,3,3,
	4,4,4,4,4,4,4,3,3,3,3,3,3,3,0,0,0,0,0,0);
	
	# ---- read version ECC data file.
	
	$byte_num=$matrix_remain_bit[$qrcode_version]+($max_codewords << 3);
	$filename=$path."/qrv".$qrcode_version."_".$ecc.".dat";
	open (IN,$filename);
	binmode(IN);
	sysread(IN,$matx,$byte_num);
	sysread(IN,$maty,$byte_num);
	sysread(IN,$masks,$byte_num);
	sysread(IN,$fi_x,15);
	sysread(IN,$fi_y,15);
	sysread(IN,$rs_ecc_codewords_chr,1);
	$rs_ecc_codewords=ord($rs_ecc_codewords_chr);
	sysread(IN,$rso,128);
	close(IN);
	
	@matrix_x_array=unpack("C*",$matx);
	@matrix_y_array=unpack("C*",$maty);
	@mask_array=unpack("C*",$masks);
	
	@rs_block_order=unpack("C*",$rso);
	
	@format_information_x2=unpack("C*",$fi_x);
	@format_information_y2=unpack("C*",$fi_y);
	
	@format_information_x1=(0,1,2,3,4,5,7,8,8,8,8,8,8,8,8);
	@format_information_y1=(8,8,8,8,8,8,8,8,7,5,4,3,2,1,0);
	
	
	$max_data_codewords=($max_data_bits >> 3);
	
	$filename = $path."/rsc".$rs_ecc_codewords.".dat";
	
	open (IN2, $filename);
	binmode(IN2);
	$i=0;
	while ($i<256) {
		sysread(IN2,$rs_cal_table_array[$i],$rs_ecc_codewords);
		$i++;
	}
	close (IN2);
	
	$qrcode_image_size=$qrcode_module_size*($max_modules_1side+8);
	
	
	# ----  set teminator 
	
	if ($total_data_bits<=$max_data_bits-4){
		$data_value[$data_counter]=0;
		$data_bits[$data_counter]=4;
	}else{
		if ($total_data_bits<$max_data_bits){
			$data_value[$data_counter]=0;
			$data_bits[$data_counter]=$max_data_bits-$total_data_bits;
		}else{
			if ($total_data_bits>$max_data_bits){
				return('overflow');
			}
		}
	}
	
	# ---- divide data per 8bits
	
	$i=0;
	$codewords_counter=0;
	$codewords[0]=0;
	$remaining_bits=8;
	
	while ($i<=$data_counter) {
		$buffer=$data_value[$i];
		$buffer_bits=$data_bits[$i];
		
		$flag=1;
		while ($flag) {
			if ($remaining_bits>$buffer_bits){  
				$codewords[$codewords_counter]=(($codewords[$codewords_counter]<<$buffer_bits) | $buffer);
				$remaining_bits-=$buffer_bits;
				$flag=0;
			}else{
				$buffer_bits-=$remaining_bits;
				$codewords[$codewords_counter]=(($codewords[$codewords_counter] << $remaining_bits) | ($buffer >> $buffer_bits));
				if ($buffer_bits==0) {
					$flag=0;
				}else{
					$buffer= ($buffer & ((1 << $buffer_bits)-1) );
					$flag=1;
				}
				$codewords_counter++;
				if ($codewords_counter<$max_data_codewords-1){
					$codewords[$codewords_counter]=0;
				}
				$remaining_bits=8;
			}
		}
		$i++;
	}
	if ($remaining_bits!=8) {
		$codewords[$codewords_counter]=$codewords[$codewords_counter] << $remaining_bits;
	}else{
		$codewords_counter--;
	}
	
	
	# ----  set padding character
	
	if ($codewords_counter<$max_data_codewords-1){
		$flag=1;
		while ($codewords_counter<$max_data_codewords-1){
			$codewords_counter++;
			if ($flag==1) {
				$codewords[$codewords_counter]=236;
			}else{
				$codewords[$codewords_counter]=17;
			}
			$flag=$flag*(-1);
		}
	}
	
	# ----  RS-ECC prepare
	
	$i=0;
	$j=0;
	$rs_block_number=0;
	@rs_temp=();
	while($i<$max_data_codewords){
		$rs_temp[$rs_block_number].=chr($codewords[$i]);
		$j++;
		if ($j>=$rs_block_order[$rs_block_number]-$rs_ecc_codewords){
			$j=0;
			$rs_block_number++;
		}
		$i++;
	}
	
	#
	# RS-ECC main
	#
	
	$rs_block_number=0;
	$rs_block_order_num=$#rs_block_order+1;
	
	while ($rs_block_number<=$rs_block_order_num){
		$rs_codewords=$rs_block_order[$rs_block_number];
		$rs_codewords=~s/\n//g;
		$rs_data_codewords=$rs_codewords-$rs_ecc_codewords;
		$rstemp=$rs_temp[$rs_block_number].(chr(0) x $rs_ecc_codewords);
		
		$j=$rs_data_codewords;
		while($j>0){
			$first=ord(substr($rstemp,0,1));
			
			if ($first!=0){
				$left_chr=substr($rstemp,1);
				$cal=$rs_cal_table_array[$first];
				$rstemp=$left_chr ^ $cal;
			}else{
				$rstemp=substr($rstemp,1);
			}
			$j--;
		}
		
		push(@codewords,unpack("C*",$rstemp));
		
		$rs_block_number++;
	}
	
	#
	# ---- put data
	#
	
	# ---- flash matrix
	
	$i=0;
	while ($i<$max_modules_1side){
		$j=0;
		while ($j<$max_modules_1side){
			$matrix_content[$j][$i]=0;
			$j++;
		}
		$i++;
	}
	
	
	# ---- attach data
	$i=0;
	while ($i<$max_codewords){
		$codeword_i=$codewords[$i];
		$j=7;
		while ($j>=0){
			$codeword_bits_number=($i << 3)+$j;
			$matrix_content[ $matrix_x_array[$codeword_bits_number] ][ $matrix_y_array[$codeword_bits_number] ]=((255*($codeword_i & 1)) ^ $mask_array[$codeword_bits_number] ); 
			$codeword_i= $codeword_i >> 1;
			$j--;
		}
		$i++;
	}
	
	
	$matrix_remain=$matrix_remain_bit[$qrcode_version];
	while ($matrix_remain){
		$remain_bit_temp = $matrix_remain + ( $max_codewords <<3);
		$matrix_content[ $matrix_x_array[$remain_bit_temp] ][ $matrix_y_array[$remain_bit_temp] ]  =  ( 255 ^ $mask_array[$remain_bit_temp] );
		$matrix_remain--;
	}
	
	
	# ---- mask select
	
	
	$min_demerit_score=0;
	$hor_master="";
	$ver_master="";
	$k=0;
	while($k<$max_modules_1side){
		$l=0;
		while($l<$max_modules_1side){
			$hor_master=$hor_master.chr($matrix_content[$l][$k]);
			$ver_master=$ver_master.chr($matrix_content[$k][$l]);
			$l++;
		}
		$k++;
	}
	
	$i=0;
	$all_matrix=$max_modules_1side*$max_modules_1side;
	while ($i<8){
		$demerit_n1=0;
		@ptn_temp=();
		$bit= 1<< $i;
		$bit_r= (~$bit) & 255;
		
		$bit_mask=chr($bit) x $all_matrix;
		$hor = $hor_master & $bit_mask;
		$ver = $ver_master & $bit_mask;
		
		$ver_and = ((chr(170) x $max_modules_1side).$ver) & ($ver.(chr(170) x $max_modules_1side));
		$ver_or = ((chr(170) x $max_modules_1side).$ver) | ($ver.(chr(170) x $max_modules_1side));
		
		$hor= ~$hor;
		$ver= ~$ver;
		$ver_and= ~$ver_and;
		$ver_or = ~$ver_or;
		
		substr($ver_and,$all_matrix,0)=chr(170);
		substr($ver_or,$all_matrix,0)=chr(170);
		
		$k=$max_modules_1side-1;
		
		while ($k){
			substr($hor,$k * $max_modules_1side,0)=chr(170);
			substr($ver,$k * $max_modules_1side,0)=chr(170);
			substr($ver_and,$k * $max_modules_1side,0)=chr(170);
			substr($ver_or,$k * $max_modules_1side,0)=chr(170);
			$k--;
		}
		
		$hor=$hor.chr(170).$ver;
		$n1_search=(chr(255) x 5)."+|".(chr($bit_r) x 5)."+";
		$n2_search1=chr($bit_r).chr($bit_r)."+";
		$n2_search2=chr(255).chr(255)."+";
		$n3_search=chr($bit_r).chr(255).chr($bit_r).chr($bit_r).chr($bit_r).chr(255).chr($bit_r);
		$n4_search=chr($bit_r);
		
		$hor_temp=$hor;
		$demerit_n3=( $hor_temp =~ s/$n3_search//g )*40;
		
		$demerit_n4=int(abs(( (100* ( ($ver=~s/$n4_search//g) /($byte_num)) )-50)/5))*10;
		
		$match_before_num=length($ver_and)+length($ver_or);
		$match_num= ( $ver_and =~ s/$n2_search1//g ) + ($ver_or =~ s/$n2_search2//g );
		$match_after_num=length($ver_and)+length($ver_or);
		$demerit_n2=($match_before_num-$match_after_num-$match_num)*3;
		
		$match_before_num=length($hor);
		$match_num= ( $hor =~ s/$n1_search//g );
		$match_after_num=length($hor);
		$demerit_n1=$match_before_num - $match_after_num - ($match_num << 1);
		
		$demerit_score=$demerit_n1+$demerit_n2+$demerit_n3+$demerit_n4;
		
		if ($demerit_score<=$min_demerit_score || $i==0){
			$mask_number=$i;
			$min_demerit_score=$demerit_score;
		}
		$i++;
	}
		
	$mask_content=1 << $mask_number;
	
	# ---- format information
	
	
	$format_information_value=(($ecc << 3) | $mask_number);
	@format_information_array=("101010000010010","101000100100101",
		"101111001111100","101101101001011","100010111111001","100000011001110",
		"100111110010111","100101010100000","111011111000100","111001011110011",
		"111110110101010","111100010011101","110011000101111","110001100011000",
		"110110001000001","110100101110110","001011010001001","001001110111110",
		"001110011100111","001100111010000","000011101100010","000001001010101",
		"000110100001100","000100000111011","011010101011111","011000001101000",
		"011111100110001","011101000000110","010010010110100","010000110000011",
		"010111011011010","010101111101101");
	
	$i=0;
	while ($i<15){
		$content=substr($format_information_array[$format_information_value],$i,1);
		$matrix_content[$format_information_x1[$i]][$format_information_y1[$i]]=$content * 255;
		$matrix_content[$format_information_x2[$i]][$format_information_y2[$i]]=$content * 255;
		$i++;
	}
	
	return(&output_image());
	
}

sub output_image{
	
	if ($gd_flag eq ""){

		$res = eval('use GD; return(1);');
		if ($res != 1){ return('gd');}

		$gd_flag = "1";
	}
	
	$image_path=$image_path."/qrv".$qrcode_version.".png";
	$output_image=GD::Image->new($qrcode_image_size,$qrcode_image_size);
	$base_image=GD::Image->newFromPng($image_path);
	
	$color[1]=$base_image->colorAllocate(0,0,0);
	$color[0]=$base_image->colorAllocate(255,255,255);
	$mxe=4+$max_modules_1side;
	
	$i=4;
	$ii=0;
	while ($i<$mxe){
		$j=4;
		$jj=0;
		while ($j<$mxe){
			if ($matrix_content[$ii][$jj] & $mask_content){
				$base_image->setPixel($i,$j,$color[1]);
			}
			$j++;
			$jj++;
		}
		$i++;
		$ii++;
	}
	
	#
	#--- output image
	#
	
	$output_image->copyResized($base_image,0,0,0,0,$qrcode_image_size,$qrcode_image_size,$max_modules_1side+8,$max_modules_1side+8);
	
	if ($qrcode_image_type eq "jpeg"){
		$output_image_data = $output_image->jpeg;
	}else{
		$output_image_data = $output_image->png;
	}
	return("1",*output_image_data);
}


